<?php

// File Security Check
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 *
 * Enqueue style and scripts
 *
 */
function slake_style_scripts() {


	//
	// Enqueueing  Stylesheet files
	//
	wp_enqueue_style( 'slake-google-fonts', slake_google_fonts_url(), array(), null );

	wp_enqueue_style( 'bootstrap', get_template_directory_uri() . '/assets/css/bootstrap.min.css' );

	wp_enqueue_style( 'font-awesome', get_template_directory_uri() . '/assets/css/font-awesome.min.css' );

	wp_enqueue_style( 'themify', get_template_directory_uri() . '/assets/css/themify-icons.css' );

	wp_enqueue_style( 'magnific-popup', get_template_directory_uri() . '/assets/css/magnific-popup.css' );

	wp_enqueue_style( 'slake-elements', get_template_directory_uri() . '/assets/css/elements.css' );

	wp_enqueue_style( 'slake-woo', get_template_directory_uri() . '/assets/css/slake-woo.css' );

	wp_enqueue_style( 'slake-switcher', get_template_directory_uri() . '/assets/css/switcher.min.css' );

	wp_enqueue_style( 'mCustomScrollbar', get_template_directory_uri() . '/assets/css/jquery.mCustomScrollbar.min.css' );

	wp_enqueue_style( 'slake-theme-colors', get_template_directory_uri() . '/assets/css/theme-colors.css' );

	wp_enqueue_style( 'slake-main', get_template_directory_uri() . '/assets/css/main.css' );

	wp_enqueue_style( 'slake-blog', get_template_directory_uri() . '/assets/css/blog.css' );

	wp_enqueue_style( 'slake-responsive', get_template_directory_uri() . '/assets/css/responsive.css' );


	//
	// Enqueueing JavaScript files
	//

	wp_enqueue_script('jquery-ui');

	wp_enqueue_script( 'bootstrap', get_template_directory_uri() . '/assets/js/bootstrap.min.js', array('jquery'), null, true );

	slake_google_maps_js_script();

	wp_enqueue_script( 'counter-up', get_template_directory_uri() . '/assets/js/counter-up.js', array('jquery'), null, true );

	wp_enqueue_script( 'nice-select', get_template_directory_uri() . '/assets/js/nice-select.js', array('jquery'), null, true );

	wp_enqueue_script( 'slick-nav', get_template_directory_uri() . '/assets/js/slick-nav.js', array('jquery'), null, true );

	wp_enqueue_script( 'magnific-popup', get_template_directory_uri() . '/assets/js/jquery.magnific-popup.min.js', array('jquery'), null, true );

	wp_enqueue_script( 'mCustomScrollbar', get_template_directory_uri() . '/assets/js/jquery.mCustomScrollbar.concat.min.js', array('jquery'), null, true );

	wp_enqueue_script( 'prettysocial', get_template_directory_uri() . '/assets/js/prettysocial.js', array('jquery'), null, true );

	wp_enqueue_script( 'sticky', get_template_directory_uri() . '/assets/js/sticky.js', array('jquery'), null, true );

	wp_enqueue_script( 'waypoints', get_template_directory_uri() . '/assets/js/waypoints.js', array('jquery'), null, true );

	wp_enqueue_script( 'swiper-slider', get_template_directory_uri() . '/assets/js/swiper-slider.js', array('jquery'), null, true );

	wp_enqueue_script( 'wow', get_template_directory_uri() . '/assets/js/wow.min.js', array('jquery'), null, true );
	
	wp_enqueue_script( 'pace', get_template_directory_uri() . '/assets/js/pace.min.js', array('jquery'), null, true );

	wp_enqueue_script( 'domain-checker', get_template_directory_uri() . '/assets/js/domain-checker.js', array('jquery'), null, true );


	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/assets/js/swiper.js', array('jquery'), null, true );

	wp_enqueue_script( 'slake-main', get_template_directory_uri() . '/assets/js/main.js', array('jquery'), null, true );

	wp_localize_script( 'domain-checker', 'slake_ajax', array(
        'ajaxurl'       => admin_url( 'admin-ajax.php' ),
        'wdc_nonce'     => wp_create_nonce( 'wdc_nonce' ),
        'siteUrl'     	=> home_url('/'),
		'whmcsBridgeUrl'     	=> slake_whmcs_bridge_url(),
		'domainCheckerUrl'     	=> slake_whmcs_bridge_url() . 'domainchecker',
    ));



	if( is_singular() && comments_open() && get_option( 'thread_comment' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

}
add_action( 'wp_enqueue_scripts', 'slake_style_scripts' );




/**
 *
 * Enqueue style and scripts in Footer
 *
 */
function slake_footer_style_scripts() {



	wp_enqueue_style( 'animate', get_template_directory_uri() . '/assets/css/animate.css');

}
add_action( 'get_footer', 'slake_footer_style_scripts' );
