<?php
namespace SlakeTS;

use SlakeTS\Widgets\Section_Title;
use SlakeTS\Widgets\Feature_Block;
use SlakeTS\Widgets\Pricing_Table;
use SlakeTS\Widgets\Info_Block;
use SlakeTS\Widgets\Slake_Button;
use SlakeTS\Widgets\Counter_Up;
use SlakeTS\Widgets\Features_Slider;
use SlakeTS\Widgets\Testimonials_Slider;
use SlakeTS\Widgets\Testimonials_Block;
use SlakeTS\Widgets\Subscribe_Form;
use SlakeTS\Widgets\Social_Links;
use SlakeTS\Widgets\Address_Info;
use SlakeTS\Widgets\Address_Block;
use SlakeTS\Widgets\Images_Carousel;
use SlakeTS\Widgets\Features_Tab;
use SlakeTS\Widgets\Pricing_Plan;
use SlakeTS\Widgets\Pricing_Table_Advanced;
use SlakeTS\Widgets\FAQ;
use SlakeTS\Widgets\ImageWithWatchVideo;
use SlakeTS\Widgets\Breadcrumb;
use SlakeTS\Widgets\Watch_Video_Button;
use SlakeTS\Widgets\Slake_Image;
use SlakeTS\Widgets\Image_With_Kit;
use SlakeTS\Widgets\Team_Slider;
use SlakeTS\Widgets\Image_Info;
use SlakeTS\Widgets\Countdown_Timer;
use SlakeTS\Widgets\About_Slider;
use SlakeTS\Widgets\Contact_Form_7;
use SlakeTS\Widgets\Google_Map;
use SlakeTS\Widgets\Hero_Header_1;
use SlakeTS\Widgets\Domain_Search;
use SlakeTS\Widgets\Domain_TLD_List;
use SlakeTS\Widgets\Floating_Clouds;
use SlakeTS\Widgets\Button_Group;
use SlakeTS\Widgets\Slake_Icon_List;
use SlakeTS\Widgets\Map_Positions;
use SlakeTS\Widgets\Blog_Posts;
use SlakeTS\Widgets\Blog_Posts_2;
use SlakeTS\Widgets\Blog_Posts_With_Scroller;

if( ! defined('ABSPATH') ) exit;

class SlakeCore{

    public function __construct() {
        $this->add_actions();
    }



    public function add_actions() {

        add_action( 'elementor/init', [$this, 'flake_elementor_helper_init'] );


        add_action( 'elementor/editor/before_enqueue_scripts', [ $this, 'enqueue_widget_styles' ] );
        add_action( 'elementor/frontend/after_enqueue_styles', [ $this, 'enqueue_widget_styles' ] );

        add_action( 'elementor/frontend/after_enqueue_styles', [ $this, 'after_register_scripts' ] );

        add_action( 'elementor/widgets/widgets_registered', [ $this, 'on_widgets_registered' ] );

    }

    function flake_elementor_helper_init(){
        \Elementor\Plugin::instance()->elements_manager->add_category(
            'slake-addons',
            [
                'title'  => 'Slake Addons',
                'icon' => 'font'
            ],
            1
        );
    }



    public function enqueue_widget_styles() {

        wp_enqueue_style( 'slake-icons', plugins_url( 'assets/css/themify.css', __FILE__ ) );
        wp_enqueue_style( 'nucleo-icons', plugins_url( 'assets/css/nucleo-font.css', __FILE__ ) );

    }


    public function after_register_scripts() {

        wp_enqueue_script( 'mailchimp-validate', get_template_directory_uri() . '/assets/js/mc-validate.js', array('jquery'), null, true );
        wp_register_script( 'countdown-time', get_template_directory_uri() . '/assets/js/countdown-time.js', array('jquery'), null, true );

    }


    public function on_widgets_registered() {
        $this->includes();
        $this->register_widget();
    }

    private function includes(){
        require __DIR__ . '/widgets/section-title.php';
        require __DIR__ . '/widgets/feature-block.php';
        require __DIR__ . '/widgets/pricing-table.php';
        require __DIR__ . '/widgets/info-block.php';
        require __DIR__ . '/widgets/flake-button.php';
        require __DIR__ . '/widgets/about-slider.php';
        require __DIR__ . '/widgets/counter-up.php';
        require __DIR__ . '/widgets/features-slider.php';
        require __DIR__ . '/widgets/testimonial-slider.php';
        require __DIR__ . '/widgets/testimonial-block.php';
        require __DIR__ . '/widgets/subscribe-form.php';
        require __DIR__ . '/widgets/social-links.php';
        require __DIR__ . '/widgets/address-info.php';
        require __DIR__ . '/widgets/address-block.php';
        require __DIR__ . '/widgets/images-carousel.php';
        require __DIR__ . '/widgets/features-tab.php';
        require __DIR__ . '/widgets/pricing-plan.php';
        require __DIR__ . '/widgets/pricing-plan-advanced.php';
        require __DIR__ . '/widgets/faq.php';
        require __DIR__ . '/widgets/img-with-watch-video.php';
        require __DIR__ . '/widgets/google-map.php';
        require __DIR__ . '/widgets/watch-video-button.php';
        require __DIR__ . '/widgets/breadcrumb.php';
        require __DIR__ . '/widgets/flake-image.php';
        require __DIR__ . '/widgets/slake-image-with-kit.php';
        require __DIR__ . '/widgets/team-slider.php';
        require __DIR__ . '/widgets/image-info.php';
        require __DIR__ . '/widgets/countdown-timer.php';
        require __DIR__ . '/widgets/contact-form-7.php';
        require __DIR__ . '/widgets/hero-header-1.php';
        require __DIR__ . '/widgets/domain-search.php';
        require __DIR__ . '/widgets/domain-tld-list.php';
        require __DIR__ . '/widgets/clouds.php';
        require __DIR__ . '/widgets/button-group.php';
        require __DIR__ . '/widgets/map-positions.php';
        require __DIR__ . '/widgets/slake-icon-list.php';
        require __DIR__ . '/widgets/blog-posts.php';
        require __DIR__ . '/widgets/blog-posts-2.php';
        require __DIR__ . '/widgets/blog-posts-3.php';
    }

    private function register_widget(){
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Hero_Header_1() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Section_Title() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Feature_Block() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Pricing_Table() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Info_Block() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Slake_Button() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Counter_Up() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Address_Info() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Address_Block() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Features_Slider() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Testimonials_Slider() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Testimonials_Block() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Subscribe_Form() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Social_Links() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new About_Slider() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Images_Carousel() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Features_Tab() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Pricing_Plan() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Pricing_Table_Advanced() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new FAQ() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new ImageWithWatchVideo() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Breadcrumb() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Watch_Video_Button() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Slake_Image() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Image_With_Kit() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Team_Slider() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Image_Info() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Countdown_Timer() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Contact_Form_7() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Google_Map() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Domain_Search() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Domain_TLD_List() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Floating_Clouds() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Button_Group() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Map_Positions() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Slake_Icon_List() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Blog_Posts() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Blog_Posts_2() );
        \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Blog_Posts_With_Scroller() );
    }

}


new SlakeCore();
