<?php

namespace SlakeTS\Shortcodes;


/**
 *
 * Slake theme shortcode class
 *
 */

class SlakeShortcodes {

	public function __construct()
	{
		add_shortcode( 'flake_social', array($this, 'flake_social_shortcode_list_render_func') );
		add_shortcode( 'slake_social_list', array($this, 'slake_social_list_render_func') );
		add_shortcode( 'slake_info_icon', array($this, 'slake_info_icon_render_func') );

	}


	public function flake_social_shortcode_list_render_func( $atts )
	{
			extract( shortcode_atts( array (
					'link' => '',
					'icon' => '',
			), $atts ) );

			$output = '';

			if(  $icon ) {
				$output .= '<a href="'. $link .'" target="_blank"><span class="'. $icon .'"></span></a>' ;
			}

			return $output;
	}


	public function slake_info_icon_render_func( $atts )
	{
		extract( shortcode_atts( array (
				'link' => 'tel:+8801711991383',
				'icon' => 'ti-headphone-alt',
				'info' => '+8801711991383',
		), $atts ) );

		$output = '<li>';

		if( $link ) {
				$output .= '<a href="'. $link .'">';
		}

		if(  $icon ) {
			$output .= '<span class="'. $icon .'"></span> ' ;
		}

		$output .= $info;

		if( $link ) {
				$output .= '</a>';
		}

		$output .= '</li>';

		return $output;
	}


	public function slake_social_list_render_func( $atts )
	{
			extract( shortcode_atts( array (
					'link' => '',
					'icon' => '',
			), $atts ) );

			$output = '<li>';

			if( $link ) {
					$output .= '<a href="'. $link .'">';
			}

			if(  $icon ) {
				$output .= '<i class="'. $icon .'"></i> ' ;
			}

			if( $link ) {
					$output .= '</a>';
			}

			$output .= '</li>';

			return $output;
	}


	/**
	 *
	 * CSS Animation Styles
	 *
	 */
	public static function animation_style_list()
	{
		$data = array(
			'None' => 'None',
			'bounce' => 'bounce',
			'flash' => 'flash',
			'pulse' => 'pulse',
			'rubberBand' => 'rubberBand',
			'shake' => 'shake',
			'swing' => 'swing',
			'tada' => 'tada',
			'wobble' => 'wobble',
			'jello' => 'jello',
			'bounceIn' => 'bounceIn',
			'bounceInRight' => 'bounceInRight',
			'bounceInDown' => 'bounceInDown',
			'bounceInUp' => 'bounceInUp',
			'bounceOut' => 'bounceOut',
			'bounceOutDown' => 'bounceOutDown',
			'bounceOutLeft' => 'bounceOutLeft',
			'bounceOutRight' => 'bounceOutRight',
			'bounceOutUp' => 'bounceOutUp',
			'fadeIn' => 'fadeIn',
			'fadeInDown' => 'fadeInDown',
			'fadeInDownBig' => 'fadeInDownBig',
			'fadeInLeft' => 'fadeInLeft',
			'fadeInRight' => 'fadeInRight',
			'fadeInLeftBig' => 'fadeInLeftBig',
			'fadeInRightBig' => 'fadeInRightBig',
			'fadeInUp' => 'fadeInUp',
			'fadeInUpBig' => 'fadeInUpBig',
			'fadeOut' => 'fadeOut',
			'fadeOutDown' => 'fadeOutDown',
			'fadeOutDownBig' => 'fadeOutDownBig',
			'fadeOutLeft' => 'fadeOutLeft',
			'fadeOutLeftBig' => 'fadeOutLeftBig',
			'fadeOutRightBig' => 'fadeOutRightBig',
			'fadeOutUp' => 'fadeOutUp',
			'fadeOutUpBig' => 'fadeOutUpBig',
			'flip' => 'flip',
			'flipInX' => 'flipInX',
			'flipInY' => 'flipInY',
			'flipOutX' => 'flipOutX',
			'flipOutY' => 'flipOutY',
			'fadeOutDown' => 'fadeOutDown',
			'lightSpeedIn' => 'lightSpeedIn',
			'lightSpeedOut' => 'lightSpeedOut',
			'rotateIn' => 'rotateIn',
			'rotateInDownLeft' => 'rotateInDownLeft',
			'rotateInDownRight' => 'rotateInDownRight',
			'rotateInUpLeft' => 'rotateInUpLeft',
			'rotateInUpRight' => 'rotateInUpRight',
			'rotateOut' => 'rotateOut',
			'rotateOutDownLeft' => 'rotateOutDownLeft',
			'rotateOutDownRight' => 'rotateOutDownRight',
			'rotateOutUpLeft' => 'rotateOutUpLeft',
			'rotateOutUpRight' => 'rotateOutUpRight',
			'slideInUp' => 'slideInUp',
			'slideInDown' => 'slideInDown',
			'slideInLeft' => 'SlideInLeft',
			'slideInRight' => 'slideInRight',
			'slideOutUp' => 'slideOutUp',
			'slideOutDown' => 'slideOutDown',
			'slideOutLeft' => 'slideOutLeft',
			'slideOutRight' => 'slideOutRight',
			'zoomIn' => 'zoomIn',
			'zoomInDown' => 'zoomInDown',
			'zoomInLeft' => 'zoomInLeft',
			'zoomInRight' => 'zoomInRight',
			'zoomInUp' => 'zoomInUp',
			'zoomOut' => 'zoomOut',
			'zoomOutDown' => 'zoomOutDown',
			'zoomOutLeft' => 'zoomOutLeft',
			'zoomOutUp' => 'zoomOutUp',
			'hinge' => 'hinge',
			'rollIn' => 'rollIn',
			'rollOut' => 'rollOut'
		);

        return $data;
	}

}

$flakeShortcodes = new SlakeShortcodes;
