<?php
/*
Plugin Name: Slake Theme Support
Plugin URI: http://themes.dhrubok.website/bufet
Description: This plugin is compatible with Slake WordPress hosting theme
Author: Ohidul
Author URI: http://ohidul.com
Version: 1.0.2
Text Domain: flake
*/


// Define the FLAKE_TS Folder
if( ! defined( 'FLAKE_TS_FILE_' ) ) {
	define('FLAKE_TS_FILE_', __FILE__ );
}


function flake_ts_load() {
    load_plugin_textdomain( 'flake-ts', false, basename( dirname( __FILE__ ) ) . '/languages' );

    // Require the main plugin file
    require( __DIR__ . '/plugin.php' );
    require( __DIR__ . '/register-custom-widget.php' );
    require( __DIR__ . '/shortcodes/shortcodes-class.php' );
    require( __DIR__ . '/includes/elementor-helper.php' );
    require( __DIR__ . '/includes/queries.php' );


}

add_action('plugins_loaded', 'flake_ts_load');



//
// Add social media share
//

add_action('single_blog_right_down', 'add_social_share_media');
add_action('archive_post_end', 'add_social_share_media');
function add_social_share_media() {

	global $post;

	echo '<div class="social-links">';
		printf('<span class="group-title-bs">%s</span>', __('Share this:', 'slake'));

		$share_media = array(
			array(
				'type'  => 'facebook',
				'icon'  => 'facebook',
			),
			array(
				'type'  => 'twitter',
				'icon'  => 'twitter-alt',
			),
			array(
				'type'  => 'linkedin',
				'icon'  => 'linkedin',
			),
			array(
				'type'  => 'pinterest',
				'icon'  => 'pinterest',
			),
			array(
				'type'  => 'googleplus',
				'icon'  => 'google',
			),

		);

		// Get the post id
		$post_id = $post->ID;

		// Get the post Title
		$post_title = get_the_title($post_id);

		$post_description = get_the_excerpt($post_id);

		// Get the post media
		$attachment_id = get_post_thumbnail_id( $post_id );
		$post_media = wp_get_attachment_image_src( $attachment_id, 'full');

		// get the post url
		$post_url = get_the_permalink();


		 foreach( $share_media as $media  ) :

			printf(
				'<a href="#"
					data-type="%s"
					data-url="%s"
					data-title="%s"
					data-description="%s"
					data-media="%s"
					target="_blank"
					class="prettySocial icon-%s"
				>
					<span class="ti-%s"></span>
				</a>',
				esc_attr( $media['type'] ),
				esc_url( $post_url ),
				esc_attr( $post_title ),
				esc_attr( $post_description ),
				esc_url( $post_media[0] ),
				esc_attr($media['type']),
				esc_attr($media['icon'])
			);

		endforeach;

	echo '</div>';

	wp_enqueue_script('prettysocial');

}
